# -*-python-*-

__package__    = "pocketMMap/Providers/__init__.py"
__version__    = "0.2b2"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/pocketMMap"
__date__       = "$Date: 2008/11/16 07:18:01 $"
__copyright__  = "Copyright (c) 2007-2008 Aaron Straup Cope. BSD license : http://www.modestmaps.com/license.txt"

import urllib2
from BeautifulSoup import BeautifulStoneSoup
from htmlentitydefs import name2codepoint as n2cp
import re
import pocketMMap

class GeoRSS (pocketMMap.pocketMMap) :

    def draw_feed (self, url, zoom=15) :

        p = re.compile("tag as ([^<]+)")

        fh = urllib2.urlopen(url)
        rss = fh.read()

        soup = BeautifulStoneSoup(rss)

        markers = []
        
        sw_lat = None
        sw_lon = None
        ne_lat = None
        ne_lon = None
        
        for i in soup.findAll('item'):

            point = i.find('georss:point')
    
            if point :

                title = i.find('title').contents[0]
                title = self.decode_htmlentities(title)

                desc = i.find('description').contents[0]
                tags = re.findall(p, desc)

                if len(tags) :
                    tags = tags[0].split(" ")

                    if "skip" in tags :
                        continue
        
                point = point.contents[0]
                pt = map(lambda x: float(x), point.strip().split(" "))

                if not sw_lat or pt[0] < sw_lat :
                    sw_lat = pt[0]
                    
                if not sw_lon or pt[1] < sw_lon :
                    sw_lon = pt[1]
                        
                if not ne_lat or pt[0] > ne_lat :
                    ne_lat = pt[0]

                if not ne_lon or pt[1] > ne_lon :
                    ne_lon = pt[1]
        
                markers.append({'label':title,'latitude':pt[0],'longitude':pt[1], 'tags':tags})

        bbox = (sw_lat,sw_lon,ne_lat,ne_lon)

        self.add_markers(markers)
        self.draw(bbox, zoom)
    
    #
    #
    #
    
    def substitute_entity (self, match):
        ent = match.group(2)
        if match.group(1) == "#":
            return unichr(int(ent))
        else:
            cp = n2cp.get(ent)

            if cp:
                return unichr(cp)
            else:
                return match.group()

    #
    #
    #
    
    def decode_htmlentities (self, string):
        entity_re = re.compile("&(#?)(\d{1,5}|\w{1,8});")
        return entity_re.subn(self.substitute_entity, string)[0]


    
